#include <l4/names/libnames.h>
#include <l4/env/errno.h>
#include <l4/sys/consts.h>
#include <l4/aes/aes256.h>

#include "aes256-client.h"

static l4_threadid_t server_id = L4_INVALID_ID;
static CORBA_Object server = &server_id;

static int check_server (void)
{
    if (l4_is_invalid_id(server_id))
    {
        if (!names_waitfor_name("aes256", &server_id, 10000)) return 1;
    }
    return 0;
}

int aes_aes256_init(aes256_context *ctx, unsigned char *k)
{
    CORBA_Environment env = dice_default_environment;
    if (check_server()) return -L4_EINVAL;
    aes256_context x_ctx;
    a_aes256_init_call(server, &x_ctx, k, &env);
    return -env._p.ipc_error;
}

int aes_aes256_done(aes256_context *ctx)
{
    return 0;
}

int aes_aes256_encrypt_ecb(aes256_context *ctx, unsigned char *buf)
{
    return 0;
}

int aes_aes256_decrypt_ecb(aes256_context *ctx, unsigned char *buf)
{
    return 0;
}
